=== modified file 'lib/lp/bugs/browser/bugtarget.py'
--- lib/lp/bugs/browser/bugtarget.py	2011-06-21 08:36:42 +0000
+++ lib/lp/bugs/browser/bugtarget.py	2011-07-28 17:31:16 +0000
@@ -1202,28 +1202,28 @@
 
     @property
     def series_list(self):
-        if IDistribution(self.context, None):
-            series = self.context.series
-        elif IProduct(self.context, None):
-            series = self.context.series
-        elif IDistroSeries(self.context, None):
+        if IDistroSeries(self.context, None):
             series = self.context.distribution.series
+        elif IDistribution(self.context, None):
+            series = self.context.series
         elif IProductSeries(self.context, None):
             series = self.context.product.series
+        elif IProduct(self.context, None):
+            series = self.context.series
         else:
             raise AssertionError("series_list called with illegal context")
         return list(series)
 
     @property
     def milestones_list(self):
-        if IDistribution(self.context, None):
-            milestone_resultset = self.context.milestones
-        elif IProduct(self.context, None):
-            milestone_resultset = self.context.milestones
-        elif IDistroSeries(self.context, None):
+        if IDistroSeries(self.context, None):
             milestone_resultset = self.context.distribution.milestones
+        elif IDistribution(self.context, None):
+            milestone_resultset = self.context.milestones
         elif IProductSeries(self.context, None):
             milestone_resultset = self.context.product.milestones
+        elif IProduct(self.context, None):
+            milestone_resultset = self.context.milestones
         else:
             raise AssertionError("milestones_list called with illegal context")
         return list(milestone_resultset)
@@ -1245,14 +1245,14 @@
         if not series_list:
             return series_buglistings
         # This would be better as delegation not a case statement.
-        if IDistribution(self.context, None):
-            backlink = BugSummary.distroseries_id
+        if IDistroSeries(self.context, None):
+            backlink = BugSummary.distroseries_id
+        elif IDistribution(self.context, None):
+            backlink = BugSummary.distroseries_id
+        elif IProductSeries(self.context, None):
+            backlink = BugSummary.productseries_id
         elif IProduct(self.context, None):
             backlink = BugSummary.productseries_id
-        elif IDistroSeries(self.context, None):
-            backlink = BugSummary.distroseries_id
-        elif IProductSeries(self.context, None):
-            backlink = BugSummary.productseries_id
         else:
             raise AssertionError("illegal context %r" % self.context)
         counts = bug_task_set.countBugs(self.user, series_list, (backlink,))

=== modified file 'lib/lp/registry/adapters.py'
--- lib/lp/registry/adapters.py	2011-03-31 12:53:27 +0000
+++ lib/lp/registry/adapters.py	2011-07-25 19:21:49 +0000
@@ -9,6 +9,7 @@
     'distroseries_to_distribution',
     'PollSubset',
     'productseries_to_product',
+    'sourcepackage_to_distribution',
     ]
 
 
@@ -28,6 +29,14 @@
     )
 
 
+def sourcepackage_to_distribution(source_package):
+    """Adapts `ISourcePackage` object to `IDistribution`.
+
+    This also supports `IDistributionSourcePackage`
+    """
+    return source_package.distribution
+
+
 def distroseries_to_distribution(distroseries):
     """Adapts `IDistroSeries` object to `IDistribution`.
 

=== modified file 'lib/lp/registry/browser/distributionsourcepackage.py'
--- lib/lp/registry/browser/distributionsourcepackage.py	2011-07-27 17:34:09 +0000
+++ lib/lp/registry/browser/distributionsourcepackage.py	2011-07-28 17:34:34 +0000
@@ -4,7 +4,6 @@
 __metaclass__ = type
 
 __all__ = [
-    'distribution_from_distributionsourcepackage',
     'DistributionSourcePackageAnswersMenu',
     'DistributionSourcePackageBreadcrumb',
     'DistributionSourcePackageChangelogView',
@@ -28,7 +27,6 @@
     getUtility,
     )
 from zope.interface import (
-    implementer,
     implements,
     Interface,
     )
@@ -116,12 +114,6 @@
             self.context.sourcepackagename.name)
 
 
-@adapter(IDistributionSourcePackage)
-@implementer(IServiceUsage)
-def distribution_from_distributionsourcepackage(dsp):
-    return dsp.distribution
-
-
 class DistributionSourcePackageFacets(QuestionTargetFacetMixin,
                                       StandardLaunchpadFacets):
 

=== modified file 'lib/lp/registry/browser/sourcepackage.py'
--- lib/lp/registry/browser/sourcepackage.py	2011-07-27 17:34:09 +0000
+++ lib/lp/registry/browser/sourcepackage.py	2011-07-28 17:34:34 +0000
@@ -41,7 +41,6 @@
     )
 from zope.formlib.form import Fields
 from zope.interface import (
-    implementer,
     implements,
     Interface,
     )
@@ -84,7 +83,6 @@
     )
 from lp.app.browser.tales import CustomizableFormatter
 from lp.app.enums import ServiceUsage
-from lp.app.interfaces.launchpad import IServiceUsage
 from lp.app.widgets.itemswidgets import LaunchpadRadioWidget
 from lp.bugs.browser.bugtask import BugTargetTraversalMixin
 from lp.registry.browser.product import ProjectAddStepOne
@@ -190,12 +188,6 @@
 
 
 @adapter(ISourcePackage)
-@implementer(IServiceUsage)
-def distribution_from_sourcepackage(package):
-    return package.distribution
-
-
-@adapter(ISourcePackage)
 class SourcePackageBreadcrumb(Breadcrumb):
     """Builds a breadcrumb for an `ISourcePackage`."""
     implements(IBreadcrumb)

=== modified file 'lib/lp/registry/configure.zcml'
--- lib/lp/registry/configure.zcml	2011-06-20 05:56:54 +0000
+++ lib/lp/registry/configure.zcml	2011-07-25 18:50:46 +0000
@@ -257,6 +257,11 @@
             interface="lp.registry.interfaces.distroseries.IDistroSeriesSet"/>
     </securedutility>
     <adapter
+        provides="lp.registry.interfaces.distribution.IDistribution"
+        for="lp.registry.interfaces.distroseries.IDistroSeries"
+        factory="lp.registry.adapters.distroseries_to_distribution"
+        permission="zope.Public"/>
+    <adapter
         provides="lp.app.interfaces.launchpad.ILaunchpadUsage"
         for="lp.registry.interfaces.distroseries.IDistroSeries"
         factory="lp.registry.adapters.distroseries_to_distribution"
@@ -532,11 +537,19 @@
                 "/>
     </class>
     <adapter
+        provides="lp.registry.interfaces.distribution.IDistribution"
+        for="lp.registry.interfaces.distributionsourcepackage.IDistributionSourcePackage"
+        factory="lp.registry.adapters.sourcepackage_to_distribution"
+        permission="zope.Public"/>
+    <adapter
         for="lp.registry.interfaces.distributionsourcepackage.IDistributionSourcePackage"
         provides="canonical.launchpad.webapp.interfaces.ILaunchpadContainer"
         factory="canonical.launchpad.components.launchpadcontainer.LaunchpadDistributionSourcePackageContainer"/>
     <adapter
-        factory="lp.registry.browser.distributionsourcepackage.distribution_from_distributionsourcepackage"/>
+        provides="lp.app.interfaces.launchpad.IServiceUsage"
+        for="lp.registry.interfaces.distributionsourcepackage.IDistributionSourcePackage"
+        factory="lp.registry.adapters.sourcepackage_to_distribution"
+        permission="zope.Public"/>
     <adapter
         factory="lp.registry.browser.distributionsourcepackage.DistributionSourcePackageBreadcrumb"/>
 
@@ -1614,9 +1627,17 @@
             interface="lp.registry.interfaces.sourcepackage.ISourcePackageFactory"/>
     </securedutility>
     <adapter
+        provides="lp.registry.interfaces.distribution.IDistribution"
+        for="lp.registry.interfaces.sourcepackage.ISourcePackage"
+        factory="lp.registry.adapters.sourcepackage_to_distribution"
+        permission="zope.Public"/>
+    <adapter
         factory="lp.registry.browser.sourcepackage.SourcePackageBreadcrumb"/>
     <adapter
-        factory="lp.registry.browser.sourcepackage.distribution_from_sourcepackage"/>
+        provides="lp.app.interfaces.launchpad.IServiceUsage"
+        for="lp.registry.interfaces.sourcepackage.ISourcePackage"
+        factory="lp.registry.adapters.sourcepackage_to_distribution"
+        permission="zope.Public"/>
 
     <!-- This is class ProductReleaseSet -->
 

=== modified file 'lib/lp/registry/tests/test_adapters.py'
--- lib/lp/registry/tests/test_adapters.py	2011-03-14 12:20:17 +0000
+++ lib/lp/registry/tests/test_adapters.py	2011-07-25 19:21:49 +0000
@@ -9,6 +9,7 @@
 from lp.registry.adapters import (
     distroseries_to_distribution,
     productseries_to_product,
+    sourcepackage_to_distribution,
     )
 from lp.registry.interfaces.distribution import IDistribution
 from lp.registry.interfaces.product import IProduct
@@ -19,13 +20,32 @@
 
     layer = DatabaseFunctionalLayer
 
+    def test_sourcepackage_to_distribution_dsp(self):
+        # A distribution can be retrieved from a dsp.
+        package = self.factory.makeDistributionSourcePackage()
+        distribution = sourcepackage_to_distribution(package)
+        self.assertTrue(IDistribution.providedBy(distribution))
+        self.assertEqual(package.distribution, distribution)
+        self.assertEqual(package.distribution, IDistribution(package))
+
+    def test_sourcepackage_to_distribution_sp(self):
+        # A distribution can be retrieved from a source package.
+        package = self.factory.makeSourcePackage()
+        distribution = sourcepackage_to_distribution(package)
+        self.assertTrue(IDistribution.providedBy(distribution))
+        self.assertEqual(package.distroseries.distribution, distribution)
+        self.assertEqual(
+            package.distroseries.distribution, IDistribution(package))
+
     def test_distroseries_to_distribution(self):
         # distroseries_to_distribution() returns an IDistribution given an
         # IDistroSeries.
         distro_series = self.factory.makeDistroSeries()
         distribution = distroseries_to_distribution(distro_series)
         self.assertTrue(IDistribution.providedBy(distribution))
-        self.assertEqual(distribution, distro_series.distribution)
+        self.assertEqual(distro_series.distribution, distribution)
+        self.assertEqual(
+            distro_series.distribution, IDistribution(distro_series))
 
     def test_productseries_to_product(self):
         # productseries_to_product() returns an IProduct given an
@@ -33,4 +53,4 @@
         product_series = self.factory.makeProductSeries()
         product = productseries_to_product(product_series)
         self.assertTrue(IProduct.providedBy(product))
-        self.assertEqual(product, product_series.product)
+        self.assertEqual(product_series.product, product)

=== modified file 'lib/lp/registry/tests/test_dsp_vocabularies.py'
--- lib/lp/registry/tests/test_dsp_vocabularies.py	2011-07-22 01:15:49 +0000
+++ lib/lp/registry/tests/test_dsp_vocabularies.py	2011-07-26 19:06:06 +0000
@@ -12,8 +12,7 @@
 
 
 class TestDistributionSourcePackageVocabulary(TestCaseWithFactory):
-    """Test that the DistributionSourcePackageVocabulary behaves as
-    expected."""
+    """Test that the vocabulary behaves as expected."""
     layer = DatabaseFunctionalLayer
 
     def test_provides_ihugevocabulary(self):
@@ -21,19 +20,140 @@
             self.factory.makeDistribution())
         self.assertProvides(vocabulary, IHugeVocabulary)
 
-    def test_toTerm_unbuilt_dsp(self):
-        # If the source has no built binaries, the term's value contains a
-        # string to that effect.
-        dsp = self.factory.makeDistributionSourcePackage(
-            sourcepackagename='foo')
-        vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
-        term = vocabulary.toTerm(dsp.name)
-        self.assertEqual(dsp.sourcepackagename.name, term.title)
-        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
-        self.assertEqual(expected_token, term.token)
-        self.assertEqual('Not yet built.', term.value)
-
-    def test_toTerm_built_single_binary(self):
+    def test_init_IDistribution(self):
+        # When the context is adaptable to IDistribution, it also provides
+        # the distribution.
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename='foo')
+        vocabulary = DistributionSourcePackageVocabulary(dsp)
+        self.assertEqual(dsp, vocabulary.context)
+        self.assertEqual(dsp.distribution, vocabulary.distribution)
+
+    def test_init_dsp_bugtask(self):
+        # A dsp bugtask can be the context
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename='foo')
+        bugtask = self.factory.makeBugTask(target=dsp)
+        vocabulary = DistributionSourcePackageVocabulary(bugtask)
+        self.assertEqual(bugtask, vocabulary.context)
+        self.assertEqual(dsp.distribution, vocabulary.distribution)
+
+    def test_init_dsp_question(self):
+        # A dsp bugtask can be the context
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename='foo')
+        question = self.factory.makeQuestion(
+            target=dsp, owner=dsp.distribution.owner)
+        vocabulary = DistributionSourcePackageVocabulary(question)
+        self.assertEqual(question, vocabulary.context)
+        self.assertEqual(dsp.distribution, vocabulary.distribution)
+
+    def test_init_no_distribution(self):
+        # The distribution is None if the context cannot be adapted to a
+        # distribution.
+        project = self.factory.makeProduct()
+        vocabulary = DistributionSourcePackageVocabulary(project)
+        self.assertEqual(project, vocabulary.context)
+        self.assertEqual(None, vocabulary.distribution)
+
+    def test_getDistributionAndPackageName_distro_and_package(self):
+        # getDistributionAndPackageName() returns a tuple of distribution
+        # and package name when the text contains both.
+        new_distro = self.factory.makeDistribution(name='fnord')
+        vocabulary = DistributionSourcePackageVocabulary(None)
+        distribution, package_name = vocabulary.getDistributionAndPackageName(
+            'fnord/pting')
+        self.assertEqual(new_distro, distribution)
+        self.assertEqual('pting', package_name)
+
+    def test_getDistributionAndPackageName_default_distro_and_package(self):
+        # getDistributionAndPackageName() returns a tuple of the default
+        # distribution and package name when the text is just a package name.
+        default_distro = self.factory.makeDistribution(name='fnord')
+        vocabulary = DistributionSourcePackageVocabulary(default_distro)
+        distribution, package_name = vocabulary.getDistributionAndPackageName(
+            'pting')
+        self.assertEqual(default_distro, distribution)
+        self.assertEqual('pting', package_name)
+
+    def test_getDistributionAndPackageName_bad_distro_and_package(self):
+        # getDistributionAndPackageName() returns a tuple of the default
+        # distribution and package name when the distro in the text cannot
+        # be matched to a real distro.
+        default_distro = self.factory.makeDistribution(name='fnord')
+        vocabulary = DistributionSourcePackageVocabulary(default_distro)
+        distribution, package_name = vocabulary.getDistributionAndPackageName(
+            'misspelled/pting')
+        self.assertEqual(default_distro, distribution)
+        self.assertEqual('pting', package_name)
+
+    def test_contains_true(self):
+        # The vocabulary contains DSPs that have SPPH in the distro.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp)
+        self.assertTrue(dsp in vocabulary)
+
+    def test_contains_false(self):
+        # The vocabulary does not contain DSPs without SPPH.
+        spn = self.factory.makeSourcePackageName(name='foo')
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename=spn)
+        vocabulary = DistributionSourcePackageVocabulary(dsp)
+        self.assertFalse(dsp in vocabulary)
+
+    def test_toTerm_raises_error(self):
+        # An error is raised for DSP/SPNs without publishing history.
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename='foo')
+        vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
+        self.assertRaises(LookupError, vocabulary.toTerm, dsp.name)
+
+    def test_toTerm_none_raises_error(self):
+        # An error is raised for SPN does not exist.
+        vocabulary = DistributionSourcePackageVocabulary(None)
+        self.assertRaises(LookupError, vocabulary.toTerm, 'non-existant')
+
+    def test_toTerm_spn_and_default_distribution(self):
+        # The vocabulary's distribution is used when only a SPN is passed.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
+        term = vocabulary.toTerm(dsp.sourcepackagename)
+        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
+        self.assertEqual(expected_token, term.token)
+        self.assertEqual(dsp.sourcepackagename, term.value)
+
+    def test_toTerm_spn_and_distribution(self):
+        # The distribution is used with the spn if it is passed.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(None)
+        term = vocabulary.toTerm(dsp.sourcepackagename, dsp.distribution)
+        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
+        self.assertEqual(expected_token, term.token)
+        self.assertEqual(dsp.sourcepackagename, term.value)
+
+    def test_toTerm_dsp(self):
+        # The DSP's distribution is used when a DSP is passed.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp)
+        term = vocabulary.toTerm(dsp)
+        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
+        self.assertEqual(expected_token, term.token)
+        self.assertEqual(dsp.sourcepackagename, term.value)
+
+    def test_toTerm_unbuilt_title(self):
+        # The DSP's distribution is used with the spn if it is passed.
+        # Published, but unbuilt packages state the case in the term title.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp)
+        term = vocabulary.toTerm(dsp)
+        self.assertEqual('Not yet built.', term.title)
+
+    def test_toTerm_built_single_binary_title(self):
         # The binary package name appears in the term's value.
         bpph = self.factory.makeBinaryPackagePublishingHistory()
         spr = bpph.binarypackagerelease.build.source_package_release
@@ -42,11 +162,9 @@
             distribution=bpph.distroseries.distribution)
         vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
         term = vocabulary.toTerm(spr.sourcepackagename)
-        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
-        self.assertEqual(expected_token, term.token)
-        self.assertEqual(bpph.binary_package_name, term.value)
+        self.assertEqual(bpph.binary_package_name, term.title)
 
-    def test_toTerm_built_multiple_binary(self):
+    def test_toTerm_built_multiple_binary_title(self):
         # All of the binary package names appear in the term's value.
         spph = self.factory.makeSourcePackagePublishingHistory()
         spr = spph.sourcepackagerelease
@@ -63,16 +181,40 @@
         dsp = spr.distrosourcepackage
         vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
         term = vocabulary.toTerm(spr.sourcepackagename)
-        expected_token = '%s/%s' % (dsp.distribution.name, dsp.name)
-        self.assertEqual(expected_token, term.token)
-        self.assertEqual(', '.join(expected_names), term.value)
+        self.assertEqual(', '.join(expected_names), term.title)
+
+    def test_getTermByToken_error(self):
+        # An error is raised if the token does not match a published DSP.
+        dsp = self.factory.makeDistributionSourcePackage(
+            sourcepackagename='foo')
+        vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
+        token = '%s/%s' % (dsp.distribution.name, dsp.name)
+        self.assertRaises(LookupError, vocabulary.getTermByToken, token)
+
+    def test_getTermByToken_token(self):
+        # The term is return if it matches a published DSP.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp.distribution)
+        token = '%s/%s' % (dsp.distribution.name, dsp.name)
+        term = vocabulary.getTermByToken(token)
+        self.assertEqual(dsp.sourcepackagename, term.value)
+
+    def test_searchForTerms_without_distribution(self):
+        # An empty result set is return if the vocabulary has no distribution
+        # and the search does not provide distribution information.
+        spph = self.factory.makeSourcePackagePublishingHistory()
+        dsp = spph.sourcepackagerelease.distrosourcepackage
+        vocabulary = DistributionSourcePackageVocabulary(dsp.name)
+        results = vocabulary.searchForTerms(dsp.name)
+        self.assertIs(0, results.count())
 
     def test_searchForTerms_None(self):
         # Searching for nothing gets you that.
         vocabulary = DistributionSourcePackageVocabulary(
             self.factory.makeDistribution())
         results = vocabulary.searchForTerms()
-        self.assertIs(None, results)
+        self.assertIs(0, results.count())
 
     def assertTermsEqual(self, expected, actual):
         # Assert two given terms are equal.
@@ -125,7 +267,7 @@
         spn = self.factory.getOrMakeSourcePackageName('xorg')
         spr = self.factory.makeSourcePackageRelease(sourcepackagename=spn)
         das = self.factory.makeDistroArchSeries()
-        spph = self.factory.makeSourcePackagePublishingHistory(
+        self.factory.makeSourcePackagePublishingHistory(
             sourcepackagerelease=spr, distroseries=das.distroseries)
         for name in ('xorg-common', 'xorg-server', 'xorg-video-intel'):
             bpn = self.factory.getOrMakeBinaryPackageName(name)
@@ -133,7 +275,7 @@
                 source_package_release=spr, distroarchseries=das)
             bpr = self.factory.makeBinaryPackageRelease(
                 binarypackagename=bpn, build=bpb)
-            bpph = self.factory.makeBinaryPackagePublishingHistory(
+            self.factory.makeBinaryPackagePublishingHistory(
                 binarypackagerelease=bpr, distroarchseries=das)
         vocabulary = DistributionSourcePackageVocabulary(
             context=das.distroseries.distribution)

=== modified file 'lib/lp/registry/vocabularies.py'
--- lib/lp/registry/vocabularies.py	2011-07-22 09:33:33 +0000
+++ lib/lp/registry/vocabularies.py	2011-07-26 19:09:48 +0000
@@ -80,6 +80,7 @@
     With,
     )
 from storm.info import ClassAlias
+from storm.store import EmptyResultSet
 from zope.component import getUtility
 from zope.interface import implements
 from zope.schema.interfaces import IVocabularyTokenized
@@ -129,7 +130,10 @@
 from lp.app.interfaces.launchpad import ILaunchpadCelebrities
 from lp.blueprints.interfaces.specification import ISpecification
 from lp.bugs.interfaces.bugtask import IBugTask
-from lp.registry.interfaces.distribution import IDistribution
+from lp.registry.interfaces.distribution import (
+    IDistribution,
+    IDistributionSet,
+    )
 from lp.registry.interfaces.distributionsourcepackage import (
     IDistributionSourcePackage,
     )
@@ -634,7 +638,7 @@
                     Person.id.is_in(public_inner_textual_select),
                     Person.visibility == PersonVisibility.PUBLIC,
                     Person.merged == None,
-                    Or(# A valid person-or-team is either a team...
+                    Or(  # A valid person-or-team is either a team...
                        # Note: 'Not' due to Bug 244768.
                        Not(Person.teamowner == None),
                        # Or a person who has a preferred email address.
@@ -830,10 +834,10 @@
                 And(
                     SQL("Person.id = MatchingPerson.id"),
                     Or(
-                        And(# A public person or team
+                        And(  # A public person or team
                             Person.visibility == PersonVisibility.PUBLIC,
                             Person.merged == None,
-                            Or(# A valid person-or-team is either a team...
+                            Or(  # A valid person-or-team is either a team...
                                 # Note: 'Not' due to Bug 244768.
                                 Not(Person.teamowner == None),
                                 # Or a person who has preferred email address.
@@ -1979,13 +1983,27 @@
 
     implements(IHugeVocabulary)
     displayname = 'Select a package'
-    step_title = 'Search'
+    step_title = 'Search by name or distro/name'
 
     def __init__(self, context):
         self.context = context
+        # Avoid circular import issues.
+        from lp.answers.interfaces.question import IQuestion
+        if IBugTask.providedBy(context) or IQuestion.providedBy(context):
+            target = context.target
+        else:
+            target = context
+        try:
+            self.distribution = IDistribution(target)
+        except TypeError:
+            self.distribution = None
 
-    def __contains__(self, obj):
-        pass
+    def __contains__(self, spn_or_dsp):
+        try:
+            self.toTerm(spn_or_dsp)
+            return True
+        except LookupError:
+            return False
 
     def __iter__(self):
         pass
@@ -1993,31 +2011,59 @@
     def __len__(self):
         pass
 
-    def toTerm(self, spn):
+    def getDistributionAndPackageName(self, text):
+        "Return the distribution and package name from the parsed text."
+        # Match the toTerm() format, but also use it to select a distribution.
+        distribution = None
+        if '/' in text:
+            distro_name, text = text.split('/', 1)
+            distribution = getUtility(IDistributionSet).getByName(distro_name)
+        if distribution is None:
+            distribution = self.distribution
+        return distribution, text
+
+    def toTerm(self, spn_or_dsp, distribution=None):
         """See `IVocabulary`."""
-        dsp = self.context.getSourcePackage(spn)
-        if dsp.publishing_history:
+        dsp = None
+        if IDistributionSourcePackage.providedBy(spn_or_dsp):
+            dsp = spn_or_dsp
+            distribution = spn_or_dsp.distribution
+        else:
+            distribution = distribution or self.distribution
+            if distribution is not None and spn_or_dsp is not None:
+                dsp = distribution.getSourcePackage(spn_or_dsp)
+        try:
             binaries = dsp.publishing_history[0].getBuiltBinaries()
-            summary = ', '.join(
-                [binary.binary_package_name for binary in binaries])
-        else:
-            summary = "Not yet built."
-        token = '%s/%s' % (dsp.distribution.name, dsp.name)
-        return SimpleTerm(summary, token, dsp.name)
+            binary_names = [binary.binary_package_name for binary in binaries]
+            if binary_names != []:
+                summary = ', '.join(binary_names)
+            else:
+                summary = 'Not yet built.'
+            token = '%s/%s' % (dsp.distribution.name, dsp.name)
+            return SimpleTerm(dsp.sourcepackagename, token, summary)
+        except (IndexError, AttributeError):
+            # Either the DSP was None or there is no publishing history.
+            raise LookupError(distribution, spn_or_dsp)
 
-    def getTerm(self, spn):
+    def getTerm(self, spn_or_dsp):
         """See `IBaseVocabulary`."""
-        return self.toTerm(spn)
+        return self.toTerm(spn_or_dsp)
 
     def getTermByToken(self, token):
         """See `IVocabularyTokenized`."""
-        pass
+        distribution, package_name = self.getDistributionAndPackageName(token)
+        return self.toTerm(package_name, distribution)
 
     def searchForTerms(self, query=None):
         """See `IHugeVocabulary`."""
-        distribution = self.context
-        if query is None:
-            return
+        if not query:
+            return EmptyResultSet()
+        distribution, query = self.getDistributionAndPackageName(query)
+        if distribution is None:
+            # This could failover to ubuntu, but that is non-obvious. The
+            # Python widget must set the default distribution and the JS
+            # widget must encourage the <distro>/<package> search format.
+            return EmptyResultSet()
         search_term = unicode(query)
         store = IStore(SourcePackagePublishingHistory)
         spns = store.using(
@@ -2057,4 +2103,5 @@
                     SourcePackageName.name.contains_string(search_term),
                     BinaryPackageName.name.contains_string(
                         search_term))).config(distinct=True)
+        # XXX sinzui 2011-07-26: This query ignored SPN branches.
         return CountableIterator(spns.count(), spns, self.toTerm)

=== modified file 'lib/lp/testing/factory.py'
--- lib/lp/testing/factory.py	2011-07-24 22:30:54 +0000
+++ lib/lp/testing/factory.py	2011-07-26 17:18:19 +0000
@@ -2068,7 +2068,7 @@
             owner = target.owner
         if description is None:
             description = self.getUniqueString('description')
-        with person_logged_in(target.owner):
+        with person_logged_in(owner):
             question = target.newQuestion(
                 owner=owner, title=title, description=description)
         return question

